from .operation import *
from .s0_base import *


VALVES_TYPE_PRV = 'PRV'
VALVES_TYPE_PSV = 'PSV'
VALVES_TYPE_PBV = 'PBV'
VALVES_TYPE_FCV = 'FCV'
VALVES_TYPE_TCV = 'TCV'
VALVES_TYPE_GPV = 'GPV'


def get_valve_schema(name: str) -> dict[str, dict[str, Any]]:
    return { 'id'         : {'type': 'str'   , 'optional': False , 'readonly': True },
             'node1'      : {'type': 'str'   , 'optional': False , 'readonly': False},
             'node2'      : {'type': 'str'   , 'optional': False , 'readonly': False},
             'diameter'   : {'type': 'float' , 'optional': False , 'readonly': False},
             'v_type'     : {'type': 'str'   , 'optional': False , 'readonly': False},
             'setting'    : {'type': 'float' , 'optional': False , 'readonly': False},
             'minor_loss' : {'type': 'float' , 'optional': False , 'readonly': False} }


def get_valve(name: str, id: str) -> dict[str, Any]:
    p = read(name, f"select * from valves where id = '{id}'")
    d = {}
    d['id'] = str(p['id'])
    d['node1'] = str(p['node1'])
    d['node2'] = str(p['node2'])
    d['diameter'] = float(p['diameter'])
    d['v_type'] = str(p['type'])
    d['setting'] = float(p['setting'])
    d['minor_loss'] = float(p['minor_loss'])
    return d


class Valve(object):
    def __init__(self, input: dict[str, Any]) -> None:
        self.type = 'valve'
        self.id = str(input['id'])
        self.node1 = str(input['node1'])
        self.node2 = str(input['node2'])
        self.diameter = float(input['diameter'])
        self.v_type = str(input['v_type'])
        self.setting = float(input['setting'])
        self.minor_loss = float(input['minor_loss'])

        self.f_type = f"'{self.type}'"
        self.f_id = f"'{self.id}'"
        self.f_node1 = f"'{self.node1}'"
        self.f_node2 = f"'{self.node2}'"
        self.f_diameter = self.diameter
        self.f_v_type = f"'{self.v_type}'"
        self.f_setting = self.setting
        self.f_minor_loss = self.minor_loss

    def as_dict(self) -> dict[str, Any]:
        return { 'type': self.type, 'id': self.id, 'node1': self.node1, 'node2': self.node2, 'diameter': self.diameter, 'v_type': self.v_type, 'setting': self.setting, 'minor_loss': self.minor_loss }

    def as_id_dict(self) -> dict[str, Any]:
        return { 'type': self.type, 'id': self.id }


def set_valve_cache(name: str, cs: ChangeSet) -> SqlChangeSet:
    old = Valve(get_valve(name, cs.operations[0]['id']))
    raw_new = get_valve(name, cs.operations[0]['id'])

    new_dict = cs.operations[0]
    schema = get_valve_schema(name)
    for key, value in schema.items():
        if key in new_dict and not value['readonly']:
            raw_new[key] = new_dict[key]
    new = Valve(raw_new)

    redo_sql = f"update valves set node1 = {new.f_node1}, node2 = {new.f_node2}, diameter = {new.f_diameter}, type = {new.f_v_type}, setting = {new.f_setting}, minor_loss = {new.f_minor_loss} where id = {new.f_id};"
    undo_sql = f"update valves set node1 = {old.f_node1}, node2 = {old.f_node2}, diameter = {old.f_diameter}, type = {old.f_v_type}, setting = {old.f_setting}, minor_loss = {old.f_minor_loss} where id = {old.f_id};"

    redo_cs = g_update_prefix | new.as_dict()
    undo_cs = g_update_prefix | old.as_dict()

    return SqlChangeSet(redo_sql, undo_sql, redo_cs, undo_cs)


def set_valve(name: str, cs: ChangeSet) -> ChangeSet:
    return execute_command(name, set_valve_cache(name, cs))


def add_valve_cache(name: str, cs: ChangeSet) -> SqlChangeSet:
    new = Valve(cs.operations[0])

    redo_sql = f"insert into _link (id, type) values ({new.f_id}, {new.f_type});"
    redo_sql += f"\ninsert into valves (id, node1, node2, diameter, type, setting, minor_loss) values ({new.f_id}, {new.f_node1}, {new.f_node2}, {new.f_diameter}, {new.f_v_type}, {new.f_setting}, {new.f_minor_loss});"

    undo_sql = f"delete from valves where id = {new.f_id};"
    undo_sql += f"\ndelete from _link where id = {new.f_id};"

    redo_cs = g_add_prefix | new.as_dict()
    undo_cs = g_delete_prefix | new.as_id_dict()

    return SqlChangeSet(redo_sql, undo_sql, redo_cs, undo_cs)


def add_valve(name: str, cs: ChangeSet) -> ChangeSet:
    return execute_command(name, add_valve_cache(name, cs))


def delete_valve_cache(name: str, cs: ChangeSet) -> SqlChangeSet:
    old = Valve(get_valve(name, cs.operations[0]['id']))

    redo_sql = f"delete from valves where id = {old.f_id};"
    redo_sql += f"\ndelete from _link where id = {old.f_id};"

    undo_sql = f"insert into _link (id, type) values ({old.f_id}, {old.f_type});"
    undo_sql += f"\ninsert into valves (id, node1, node2, diameter, type, setting, minor_loss) values ({old.f_id}, {old.f_node1}, {old.f_node2}, {old.f_diameter}, {old.f_v_type}, {old.f_setting}, {old.f_minor_loss});"

    redo_cs = g_delete_prefix | old.as_id_dict()
    undo_cs = g_add_prefix | old.as_dict()

    return SqlChangeSet(redo_sql, undo_sql, redo_cs, undo_cs)


def delete_valve(name: str, cs: ChangeSet) -> ChangeSet:
    return execute_command(name, delete_valve_cache(name, cs))


class InpValve:
    def __init__(self, line: str) -> None:
        tokens = line.split()

        num = len(tokens)
        has_desc = tokens[-1].startswith(';')
        num_without_desc = (num - 1) if has_desc else num

        self.id = str(tokens[0])
        self.node1 = str(tokens[1])
        self.node2 = str(tokens[2])
        self.diameter = float(tokens[3])
        self.v_type = str(tokens[4])
        self.setting = float(tokens[5])
        self.minor_loss = float(tokens[6])
        self.desc = str(tokens[-1]) if has_desc else None


def inp_in_valve(section: list[str]) -> ChangeSet:
    cs = ChangeSet()
    for s in section:
        # skip comment
        if s.startswith(';'):
            continue
        obj = InpValve(s)
        cs.append(g_add_prefix | {'type': 'valve', 'id': obj.id, 'node1': obj.node1, 'node2': obj.node2, 'diameter': obj.diameter, 'v_type': obj.v_type, 'setting': obj.setting, 'minor_loss': obj.minor_loss})
    return cs


def inp_out_valve(name: str) -> list[str]:
    lines = []
    objs = read_all(name, 'select * from valves')
    for obj in objs:
        id = obj['id']
        node1 = obj['node1']
        node2 = obj['node2']
        diameter = obj['diameter']
        v_type = obj['type']
        setting = obj['setting']
        minor_loss = obj['minor_loss']
        desc = ';'
        lines.append(f'{id} {node1} {node2} {diameter} {v_type} {setting} {minor_loss} {desc}')
    return lines
